from abc import ABC, abstractmethod
"""
Created on Tue Jan 21 16:26:13 2025

@author: Matthias Quintern
"""

class LedControlDevice(ABC):
    @abstractmethod 
    def on(self):
        """
        Set the led brightness to 100%

        Returns
        -------
        None.
        """
        pass
    
    @abstractmethod
    def off(self):
        """
        Set the led brightness to 0%

        Returns
        -------
        None.
        """
        pass
    
    @abstractmethod
    def set_level(self, level:int):
        """
        Set the led brightness to a certain level

        Parameters
        ----------
        level : int
            Brightness level in percent.

        Returns
        -------
        None.
        """
        pass

    @abstractmethod
    def __str__(self):
        pass